'****************************************************************
'*  Name    : LCD_Tricks.inc                                    *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2016 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 10/01/2016                                        *
'*  Version : 1.0                                               *
'*  Notes   :                                                   *
'*          :                                                   *
'****************************************************************


$ifndef _LCD_Tricks_
$define _LCD_Tricks_
'-------------------------------------------------------------------------------
    GoTo OverLCD_Tricks
'*******************************************************************************    
' Definition of the Local Variables of this library.

' Definition of local Bytes
$ifndef _LVBS_Block1_
    $define _LVBS_Block1_
    Dim LVSByte1 As Byte System     ' Local Variable System Byte1
    Dim LVSByte2 As Byte System     ' Local Variable System Byte2
    Dim LVSByte3 As Byte System     ' Local Variable System Byte3
    Dim LVSByte4 As Byte System     ' Local Variable System Byte4
$endif

$ifndef _LVBS_Block2_
    $define _LVBS_Block2_
    Dim LVSByte5 As Byte System     ' Local Variable System Byte5
    Dim LVSByte6 As Byte System     ' Local Variable System Byte6
    Dim LVSByte7 As Byte System     ' Local Variable System Byte7
    Dim LVSByte8 As Byte System     ' Local Variable System Byte8
$endif

' Definition of local Words
$ifndef _LVWS_Block1_
    $define _LVWS_Block1_
    Dim LVSWord1 As Word System     ' Local Variable System Word1
    Dim LVSWord2 As Word System     ' Local Variable System Word2
$endif


'===============================================================================
'(*
'    Here are some of the standard LCD commands
    
    Symbol LcdCmd = 254             ' Command mode
    Symbol LcdClr = $01             ' Clear Display
    Symbol LcdHome = $02            ' Return home (beginning of first line)
    Symbol LcdUnderlineOff = $0C    ' Underline Cursor Off
    Symbol LcdUnderlineOn = $0E     ' Underline Cursor On
    Symbol LcdBlinkingOff = $0C     ' Blinking Box Cursor Off
    Symbol LcdBlinkingOn = $0F      ' Blinking Box Cursor On
    Symbol LcdCurMoveLeft = $10     ' Move Cursor Left one position
    Symbol LcdCurMoveRight = $14    ' Move Cursor Right one position
    Symbol LcdHome2 = $C0           ' Move cursor to beginning of second line
    Symbol LcdHome3 = $94           ' Move cursor to beginning of third line (if applicable)
    Symbol LcdHome4 = $D4           ' Move cursor to beginning of fourth line (if applicable)
    Symbol LcdScrollRight = $1C     ' Scroll entire screen Right one space
    Symbol LcdScrollLeft = $18      ' Scroll entire screen Left one space
    Symbol LcdDisplayOff = $08      ' Turn visible LCD off
    Symbol LcdDisplayOn = $0C       ' Turn visible LCD on
    
'    example
'    Print LcdCmd, LcdBlinkingOn

' Written by Dave 
'*)
'===============================================================================

$define LCD_Clear() Print LcdCmd, LcdClr                    ' Clear the LCD screen.

$define LCD_LcdHome() Print LcdCmd, LcdHome                 ' Return home (beginning of first line)

$define LCD_UnderlineOff() Print LcdCmd, LcdUnderlineOff    ' Underline Cursor Off 

$define LCD_UnderlineOn() Print LcdCmd, LcdUnderlineOn      ' Underline Cursor On 

$define LCD_BlinkingOff() Print LcdCmd, LcdBlinkingOff      ' Blinking Box Cursor Off

$define LCD_BlinkingOn() Print LcdCmd, LcdBlinkingOn        ' Blinking Box Cursor On

$define LCD_CurMoveLeft() Print LcdCmd, LcdCurMoveLeft      ' Move Cursor Left one position

$define LCD_CurMoveRight() Print LcdCmd, LcdCurMoveRight    ' Move Cursor Right one position

$define LCD_Home2() Print LcdCmd, LcdHome2                  ' Move cursor to beginning of second line

$define LCD_Home3() Print LcdCmd, LcdHome3                  ' Move Cursor To beginning of third Line (If applicable)

$define LCD_Home4() Print LcdCmd, LcdHome4                  ' Move Cursor To beginning of fourth Line (If applicable)

$define LCD_ScrollRight() Print LcdCmd, LcdScrollRight      ' Scroll entire screen Right one space

$define LCD_ScrollLeft() Print LcdCmd, LcdScrollLeft        ' Scroll entire screen Left one space

$define LCD_DisplayOff() Print LcdCmd, LcdDisplayOff        '  Turn visible LCD off

$define LCD_DisplayOn() Print LcdCmd, LcdDisplayOn          '  Turn visible LCD ON


'-------------------------------------------------------------------------------
$define LCD_BackLightOff() Low LCD_Backlight

$define LCD_BackLightOn() High LCD_Backlight

'=============================================================================== 
' Function Name     : Definicin de los parametros de compilacin
' Nmero Rutina     : HSR03   : Version 1.00
' Notas             : Aqui se definen todas las funciones que se van a necesitar 
'                   : en este tutorial
    $ifndef On
        $define On 1
    $endif
    $ifndef Off    
        $define Off 0
    $endif
    $ifndef Yes    
        $define Yes 1
    $endif
    $ifndef Si    
        $define Si 1
    $endif
    $ifndef No    
        $define No 0
    $endif
    $ifndef Verdadero    
        $define Verdadero 1
    $endif
    $ifndef Falso    
        $define Falso 0
    $endif
    $ifndef OK    
        $define OK 1
    $endif
'===============================================================================
' Function Name     : SetCursor
' Routine Number    : YY62  : Version Number 1.00
' Input Variables   : 
' Output Variables  : 
' Syntax            : Set_Cursor(Row, Col)
' Notes             : 
'                   : we count rows starting w/0            
'
$define Set_Cursor(pValue1,pValue2) Cursor pValue1,pValue2

$define LCD_Set_Cursor(pValue1,pValue2) Cursor pValue1,pValue2

$define LCD_Cursor(pValue1,pValue2) Cursor pValue1,pValue2
    
'-------------------------------------------------------------------------------
' Function Name     : Print Cdata File Version to the LCD display
' Author            : [Alberto Freixanet]
' Date              : 11/08/2013
' Routine Number    : AML71 : Versin 1.0
' Input Variables   : 2: LABEL,Line Number of the display
' Output Variables  : none
' Syntax            : PrintTXT(LABEL, Row)
'                   : using the powerfull modifier 'CStr' of the compiler. 
' Notes             : Print the String To the LCD defined in LABEL written with CData
'                   : It is not necessary to write a STRG_TABLE. This code is shorter if
'                   : every String of Cdata is written only once.
' Using the Preprocessor commands: see the Amicus18 Compiler Manual page 365.
'

    ' Using locals variables
'    Dim zStrgTxt As MyWordArrayTemp#0   ' Address of String of Cdata
'    Dim zRow As MyByteArrayTemp#0       ' Row position
    Dim zStrgTxt As LVSByte1        ' Local Variable System Byte1
    Dim zRow     As LVSByte2        ' Row position

$define PrintFileVersion(pValue1,pValue2)  _mPrintFileVersion pValue1,pValue2

_mPrintFileVersion Macro- pValue1,pValue2
    #if (Prm_Count != 2)
    	#error "_mPrintFileVersion - Should have two parameters (LABEL) and Num8"
    #else
		#if (Prm_1 != Label)
			#error "_mPrintFileVersion - (Param 1) should be a pointer to a LABEL"
			Exitm
        #endif
		#if (Prm_2 != Num8)
			#error "_mPrintFileVersion - (Param 2) should be a NUM8"
            Exitm
        #else
            #if (Prm_1 == Label)
                Num_Word pValue1, zStrgTxt
            #endif
            #if (Prm_2 == Num8)
                #if(pValue2 == 0)    
                    #error "_mPrintFileVersion - (Param2) Should be > 0"
                    Exitm
                #endif    
                #if(pValue2 > LCD#LINES)    
                    #error "_mPrintFileVersion - (Param2) Should be <= LCD#LINES (number of LCD lines)"
                    Exitm
                #endif
                Num_Byte pValue2, zRow
                GoSub _mPrintFileVersion_Sub
            #endif
        #endif                
	#endif
Endm
    
#ifMacro- _mPrintFileVersion
_mPrintFileVersion_Sub:
    If zRow = 1 Then
        LCD_Clear_Row1()    ' Clear LCD line 1 and set the cursor to first column position.
    Else
        LCD_Clear_Row2()    ' Clear LCD line 2 and set the cursor to first column position.
    EndIf
    Print CStr zStrgTxt     ' Send the Display the Cdata String.
    Return
#endIfMacro-
'*******************************************************************************
'-------------------------------------------------------------------------------
' Function Name     : Clear Row 2 
' Routine Number    : YY71  : Version Number 1.01
' Input Variables   : 
' Output Variables  : 
' Syntax            : LCD_Clear_Row2()
' Notes             : 
' []                : This command takes a long time! 0,5mS
' Write a "SPACE" to the LCD column 1 to column 16, Row2, and place the cursor in column1, Row2.

    Dim _jLCD_Index As LVSByte1
    Dim _mCUR_Chrs  As LVSByte2
    Dim jCUR_Row    As LVSByte3
    Dim jCUR_Col    As LVSByte4
       
$define LCD_Clear_Row2() mClear_Row2

mClear_Row2 Macro-
    GoSub mClear_Row2_Sub
Endm

#ifMacro- mClear_Row2
mClear_Row2_Sub:
    Set_Cursor(2,1)         ' Set the Cursor to the Row2, Column1
    _jLCD_Index = 0
    Repeat
        Print $20           ' Print a Blank
        Inc _jLCD_Index     ' Increment the index
    Until _jLCD_Index > 15  
    Set_Cursor(2,1)         ' Set the Cursor to the Row2, Column1 
    Return
#endIfMacro-
'===============================================================================
' Nombre Funcin    : Print a Piece Of String, Imprimir un trozo de una frase. 
' Nmero Rutina     : AML20 : Versin 1.00
' Autor                 : [Alberto Freixanet]
' Variable de entrada   : String Number, primer caracter, ultimo caracter
' Variable de salida    : Enviar un texto definido en la tabla al LCD
' Sintaxis              : Print_POStrg(Numero frase, primer caracter, ultimo caracter)
' Notas                 : primer caracter = del 1 a MaxCharactersToRead
'                       : ultimo caracter = del 1 a MaxCharactersToRead
' Como las entradas son numericas, he podido escribir muchos controles para evitar
' entrar valores equivocados. Los valores no pueden ser igual a 0, ni superior al valor
' mximo permitido por MaxCharactersToRead. Ademas el primer caracter no puede ser
' superior al ltimo caracter. Todo est controlado. Cualquier error dar un fallo
' al compilar. Si ocurre ver el comentario abajo de la pgina para conocer el error cometido.
' El valor max MaxCharactersToRead est ajustado a 30 para cojer caracteres de frases
' previstas para el terminal que no estn limitas al tamaos del LCD (16 caracteres).
'
' 09/10/2013 Modification: Change Break for Return. More faster.
'
' Si la libreria esta definida
'
' Estas variables ya estn definidas anteriormente.
'    Dim mCRCommand As MyByteArrayTemp#0     ' Alias para variable local
'    Dim pNumString As MyByteArrayTemp#1     ' Alias para variable local
'    Dim mDataByte As MyByteArrayTemp#2      ' Alias para Variable local
'    Dim pAddressString As MyWordArrayTemp#0 ' Alias para Variable local
' Nuevas variables para definir
'    Dim mFirstCharacter As MyByteArrayTemp#3        ' Alias para Variable local    
'    Dim mLastCharacter As MyByteArrayTemp#4         ' Alias para Variable local
'    Dim mFinalAddressString As MyWordArrayTemp#1    ' Alias para Variable local
'    Symbol MaxCharactersToRead = 30            
    $define MaxCharactersToRead 30 

' Alias para variable local
'    Dim mCRCommand As LVSByte1          
    Dim zNumString As LVSByte1
    Dim zDataByte  As LVSByte2
    Dim zAddressString As LVSWord1

    Dim zFirstCharacter     As LVSByte3
    Dim zLastCharacter      As LVSByte4
    Dim zFinalAddressString As LVSWord2

             

$define PrintPOStrg(pValue,pFirstChar,pLastChar) _mPrintPOStrg pValue,pFirstChar,pLastChar

_mPrintPOStrg Macro- pValue,pFirstChar,pLastChar
    #if (Prm_Count > 3)
	   #error "_mPrintPOStrg - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 3)
            #error "_mPrintPOStrg - Too few parameters"
            Exitm
        #else
            #if(Prm_1 != Num8)
                #error "_mPrintPOStrg - (Param1) Should be a Num8"
                Exitm
            #endif
            #if(Prm_2 != Num8)
                #error "_mPrintPOStrg - (Param2) Should be a Num8"
                Exitm
            #endif
            #if(Prm_3 != Num8)
                #error "_mPrintPOStrg - (Param3) Should be a Num8"
                Exitm
            #else
                #if (Prm_1 == Num8) 
                    #if(pValue == 0)    
                        #error "_mPrintPOStrg - (Param1) Should be > 0"
                        Exitm
                    #endif                   
                    #if (pValue > LastString)    
                        #error "_mPrintPOStrg - (Param1) Should be <= NumStringMax"
                        Exitm
                    #else
                        Num_Byte pValue, zNumString                    
                    #endif
                #endif
                #if (Prm_2 == Num8) 
                    #if (pFirstChar == 0)    
                        #error "_mPrintPOStrg - (Param2) Should be > 0"
                        Exitm
                    #endif
                    #if (pFirstChar > pLastChar)    
                        #error "_mPrintPOStrg - (Param2) Should be <= (Param3)"
                        Exitm
                    #else
                        Num_Byte pFirstChar, zFirstCharacter                    
                    #endif
                #endif
                #if (Prm_3 == Num8) 
                    #if (pLastChar == 0)    
                        #error "_mPrintPOStrg - (Param3) Should be > 0"
                        Exitm
                    #endif
                    #if (pLastChar > MaxCharactersToRead)    
                        #error "_mPrintPOStrg - (Param3) Should be <= MaxCharactersToRead"
                        Exitm
                    #else
                        Num_Byte pLastChar, zLastCharacter                    
                    #endif
                #endif                
                GoSub _mPrintPOStrg_Sub
            #endif
        #endif
    #endif
Endm
'
#ifMacro- _mPrintPOStrg 
_mPrintPOStrg_Sub:
    zFirstCharacter = zFirstCharacter - 1                   ' Better begins from 0 to N-1.
    zLastCharacter = zLastCharacter - 1                     ' Better begins from 0 to N-1.
    ' Read each character of the string
    'zNumString = zNumString - 1                             ' Looking for 0 to N-1  Strings
'    zAddressString = LRead16 STRG_TABLE[zNumString]         ' Find the position in the memory
    zAddressString = CRead16 STRG_TABLE[zNumString]         ' Find the position in the memory
    zFinalAddressString = zAddressString + zLastCharacter   ' Compute the last position to read
    zAddressString = zAddressString + zFirstCharacter       ' Compute the first position to read
    Repeat                                                  ' Generate a finite loop
        zDataByte = LRead zAddressString        ' Scan the string. mDataByte => local variable
        If zDataByte = 0 Then                   ' It is security, max only until the final "0".
            Return                              ' 0 is the end character of the string.       
        EndIf                                   ' Stop to read          
        Print zDataByte                         ' Print the character to the LCD
        Inc zAddressString                      ' Find the next character
    Until zAddressString > zFinalAddressString  ' Check if this the end of string needed.

    Return                      
#endIfMacro-
'===============================================================================

'-------------------------------------------------------------------------------
' Function Name     : Clear number of Chareacters on line 1 or 2
' Routine Number    : YY72  : Version Number 1.00
' Input Variables   : 
' Output Variables  : 
' Syntax            : Clear_LCD_Chrs(Row,Column,Characters)
' Notes             : 
' 
$define Clear_LCD_Chrs(pValue1,pValue2,pValue3) mClear_Chrs pValue1,pValue2,pValue3

$define LCD_ClearChrs(pValue1,pValue2,pValue3) mClear_Chrs pValue1,pValue2,pValue3

mClear_Chrs Macro- pValue1,pValue2,pValue3
    #if (Prm_Count > 3)
	   #error "mClear_Chrs - Too many parameters"
       Exitm
    #else
        #if (Prm_Count < 3)
            #error "mClear_Chrs - Too few parameters"
            Exitm
        #else
            #if(Prm_1 != Byte) && (Prm_1 != Num8)
                #error "mClear_Chrs - (Param1) Should be a Byte or Num8"
                Exitm
            #endif
            #if(Prm_2 != Byte) && (Prm_2 != Num8)
                #error "mClear_Chrs - (Param2) Should be a Byte Or Num8"
                Exitm
            #endif
            #if(Prm_3 != Byte) && (Prm_3 != Num8)
                #error "mClear_Chrs - (Param3) Should be a Byte Or Num8"
                Exitm                                
            #else
                #if (Prm_1 == Byte) 
                    Byte_Byte pValue1,jCUR_Row         
                #endif
                #if (Prm_1 == Num8) 
                    Num_Byte pValue1,jCUR_Row         
                #endif
                #if (Prm_2 == Byte) 
                    Byte_Byte pValue2,jCUR_Col         
                #endif   
                #if (Prm_2 == Num8) 
                    Num_Byte pValue2,jCUR_Col         
                #endif                 
                #if (Prm_3 == Byte) 
                    Byte_Byte pValue3,_mCUR_Chrs         
                #endif   
                #if (Prm_3 == Num8) 
                    Num_Byte pValue3,_mCUR_Chrs         
                #endif                
                GoSub mClear_Chrs_Sub
            #endif
        #endif
    #endif
Endm

#ifMacro- mClear_Chrs
mClear_Chrs_Sub:
    Set_Cursor(jCUR_Row,jCUR_Col)   ' Set the Cursor to the line= Row, Column1
    _jLCD_Index = 0
    Repeat
        LCD_Data($20)               ' Send a SPACE to the LCD
        Inc _jLCD_Index             ' Increment the index
    Until _jLCD_Index > _mCUR_Chrs  ' Until the last number of characters deleted
    Set_Cursor(jCUR_Row,jCUR_Col)   ' Set the Cursor to the Origin position.
    Return
#endIfMacro-
' Nombre Funcin    : Alternative To the standard Proton Cls command
' Nmero Rutina     : YY80 : Versin 1.0
' Variable de entrada   : 
' Variable de salida    :  
' Sintaxis              : CLL {Line, {Pos}} Command
' Notas                 : Ayuda al compilador para borrar caracteres del LCD.
'
' For users still using an alphanumeric LCD this provides a useful enhanced
' alternative to the standard Proton CLS command.  When invoked with no parameters
' it will perform a standard Proton CLS, however, if you add a line number argument
' it will clear just that line, if you add a second argument (Position) it will clear
' from that position to the end of the line leaving the cursor at the beginning of the clear.
'
' CLL {Line, {Pos}} Command
'
'      With no arguments same as proton CLS
'
'      With 1 argument (Line), clears line specified in argument
'      Con 1 argumento (Linea), borra la lnea especificada en el argumento
'
'      With 2 arguments (Line, Pos), clears to end of Line from Position
'      Con 2 argumentos (Linea, Posicin), borra el final de la lnea desde el argumento Posicin
'
'$define CLL(pValue1, pValue2) _mCLL pValue1, pValue2
 
'_mCLL Macro- pValue1, pValue2
'    #if (Prm_Count >  2)
'        #error "_mCLL - Too many parameters"
'    #else
'        #if (Prm_Count == 0)
''      Add additional code for no params here .......
'        Cls    ' Here is the additional code added after the generator has produced the outline
'        #else
'            #if (Prm_1 != Byte) && (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Num32)
'                #error "_mCLL - Line(Param 1) should be a Byte variable or number"
'            #endif
'            #if (Prm_2 != Byte) && (Prm_2 != Num8) && (Prm_2 != Num16) && (Prm_2 != Num32)
'                #error "_mCLL - Pos(Param 2) should be a Byte variable or number"
'            #endif
'            #if (Prm_1 == Byte)
'                Byte_Byte pValue1, jCUR_Row
'            #endif
'            #if (Prm_1 == Num8)
'                Num_Byte pValue1, jCUR_Row
'            #endif
'            #if (Prm_1 == Num16)
'                Num_Byte pValue1, jCUR_Row
'            #endif
'            #if (Prm_1 == Num32)
'                Num_Byte pValue1, jCUR_Row
'            #endif
'            #if (Prm_2 == Byte)
'                Byte_Byte pValue2, jCUR_Col
'            #endif
'            #if (Prm_2 == Num8)
'                Num_Byte pValue2, jCUR_Col
'            #endif
'            #if (Prm_2 == Num16)
'                Num_Byte pValue2, jCUR_Col
'            #endif
'            #if (Prm_2 == Num32)
'                Num_Byte pValue2, jCUR_Col
'            #endif
'            GoSub _mCLL_Sub
'        #endif
'    #endif
'Endm

'#ifMacro- _mCLL
'_mCLL_Sub:
'' To see the results of the modifications: Read page 264 of the manual.
''    Set_Cursor(jCUR_Row, jCUR_Col)
''    Print Rep " "\__LCD_NoCharacters - jCUR_Col + 1
''    Set_Cursor(jCUR_Row, jCUR_Col)
''    Return
''
'    Set_Cursor(jCUR_Row, jCUR_Col)
'    CUR_Chrs = __LCD_NoCharacters - jCUR_Col
'    _jLCD_Index = 1
'    Repeat
'        LCD_Data($20)               ' Send a SPACE to the LCD
'        Inc _jLCD_Index               ' Increment the index
'    Until _jLCD_Index > CUR_Chrs      ' Until the last number of characters deleted
'    Set_Cursor(jCUR_Row,jCUR_Col)   ' Set the Cursor to the Origin position.
'    Return
'#endIfMacro-
'Note  This macro requires a constant __LCD_NoCharacters to be defined to reflect your
' hardware configuration.  E.g. Symbol __LCD_NoCharacters = 16 for a 16 character display. 
'-------------------------------------------------------------------------------
' Function Name: Clear the line 1 of the LCD.
' Input        : number of line
' Output       : none
' Syntax       : LCD_Clear_Row(Number Line)
' Notes        : 
' Write a "SPACE" to the LCD column 1 to column 16, Row1, and place the cursor in column1, Row1.

    Dim _xNbLines   As LVSByte1
    Dim _mLCD_Index As LVSByte2

$define LCD_Clear_Row(pValue) mClear_Row pValue

mClear_Row Macro- pValue
    #if (Prm_Count > 1)
   	    #error "LCD_Clear_Row - Too many parameters"
   	    Exitm
    #else
    	#if (Prm_Count < 1)
    		#error "LCD_Clear_Row - Too few parameters"
    	    Exitm
        #else
    		#if (Prm_1 != Num8)
    			#error "LCD_WriteContrast Macro - (Param1) Should be a Num8"
    		    Exitm
            #else
                #ifdef __LCD_LINES
                    #if (pValue >__LCD_LINES)
                        #error "There is NO such line in this LCD"
                        Exitm
                    #else
                        Num_Byte pValue, _xNbLines
                    #endif
                    GoSub mClear_Row_Sub  
                #else
                    #error "The number of lines is not declared"
                    Exitm                
                #endif                    
            #endif
        #endif            
    #endif
Endm

#ifMacro- mClear_Row
mClear_Row_Sub:
    Cursor _xNbLines,1          ' Set the Cursor to the origin.
    _mLCD_Index = 0
    Repeat
        #ifdef WatchDog_Req
        Clrwdt
        #endif
        Print $20               ' Print a Blank
        Inc _mLCD_Index         ' Increment the index
    Until _mLCD_Index > 15  
    Cursor _xNbLines,1          ' Set the Cursor to the origin.
    Return
#endIfMacro-        
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
' Function Name     : Clear Row 1
' Routine Number    : YY70  : Version Number 1.01
' Input Variables   : 
' Output Variables  : 
' Syntax            : LCD_Clear_Row1()
' Notes             : 
'                   : This command takes a long time! 
' Write a "SPACE" to the LCD column 1 to column 16, Row1, and place the cursor in column1, Row1.

$define LCD_Clear_Row1() mClear_Row1

mClear_Row1 Macro-
    GoSub mClear_Row1_Sub
Endm

#ifMacro- mClear_Row1
mClear_Row1_Sub:
    Set_Cursor(1,1)             ' Set the Cursor to the Row1, Column1
    _jLCD_Index = 0
    Repeat
        Print $20               ' Print a Blank
        Inc _jLCD_Index         ' Increment the index
    Until _jLCD_Index > 15  
    Set_Cursor(1,1)             ' Set the Cursor to the Row1, Column1 
    Return
#endIfMacro-
'*******************************************************************************
OverLCD_Tricks:
$endif

