'****************************************************************
'*  Name    : PICDEM2_18F452_4.inc                              *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2016 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 29/01/2016                                        *
'*  Version : 1.0                                               *
'*  Notes   :                                                   *
'*          :                                                   *
'****************************************************************
'
' Header file for the PICDEM2 Microchip board.
' Using a 18F452 Device with a 4MHz Oscillator
'
    Device = 18F452
    Declare Xtal = 4
    Declare Optimiser_Level = 2
    Declare Dead_Code_Remove = 1

    'Definition LCD
    Declare LCD_DTPin = PORTD.0         'Bus location data de 0 to 3	
    Declare LCD_RSPin = PORTA.3
    Declare LCD_ENPin = PORTA.1
    Declare LCD_RWPin = PORTA.2         'PORTA.2 Define the Read/Write pin
    Declare LCD_Interface = 4           ' 4-bit Interface
    Declare LCD_Lines = 2
    Declare LCD_Type = 0
    Declare LCD_CommandUs = 4000    
    Declare LCD_DataUs = 50
'
    'I2C port BUSin/BUSout   		
'	Declare SCL_Pin	= PORTC.3
'	Declare SDA_Pin	= PORTC.4
    
    Declare Serial_Baud = 9600
    Declare Rsout_Pin = PORTC.6
    Declare Rsout_Mode = 0
    Declare Rsout_Pace = 1000
    Declare Rsin_Pin = PORTC.7
    Declare Rsin_Mode = 0

    Declare Hserial_Baud = 9600                 ' Set baud rate to 9600
    Declare Hserial_RCSTA = %10010000           ' Enable serial port and continuous receive
    Declare Hserial_TXSTA = %00100100           ' Enable transmit and asynchronous mode
    Declare Hserial_Clear = On                  ' Enable Error clearing on received characters

    Declare CCP1_Pin = PORTC.2
    Declare CCP2_Pin = PORTC.1

    Symbol T300 = 3313
    Symbol N300 = 3313 + $4000
    Symbol T600 = 1646
    Symbol N600 = 1646 + $4000
    Symbol T1200 = 813
    Symbol N1200 = 813 + $4000
    Symbol T2400 = 396
    Symbol N2400 = 396 + $4000
    Symbol T4800 = 188
    Symbol N4800 = 188 + $4000
    Symbol T9600 = 84
    Symbol N9600 = 84 + $4000

    Symbol OT2400 = 396 + $8000                 ' Open True
    Symbol OT1200 = 813 + $8000                 ' Open True
    Symbol OT9600 = 84 + $8000                  ' Open True
    Symbol OT300 = 3313 + $8000                 ' Open True

    Symbol ON2400 = 396 + $4000 + $8000         ' Open Inverted
    Symbol ON1200 = 813 + $4000 + $8000         ' Open Inverted
    Symbol ON9600 = 84 + $4000 + $8000          ' Open Inverted
    Symbol ON300 = 3313 + $4000 + $8000         ' Open Inverted

' Rsout / Serial Constants
	Symbol HOME = 1
	Symbol BELL = 7
	Symbol BKSP = 8
	Symbol TAB = 9
    Symbol CR = 13      ' carriage return
    Symbol LF = 10      ' Linefeed
    Symbol BS = 08      ' Backspace
    Symbol ESC = $1B    ' Escape
    Symbol TRUE = 1
    Symbol FALSE = 0
    Symbol ACK = 6
    Symbol STX = 2
    Symbol ETX = 3
    Symbol _SPACE = $20

    ' LEDs definitions
    Symbol LED2 = LATB.0
    Symbol LED3 = LATB.1
    Symbol LED4 = LATB.2
    Symbol LED5 = LATB.3    

    Symbol Buzzer = LATC.2

    Declare All_Digital = TRUE                  ' Set PORTA and PORTE to all digital 
    
$define _PICDEM2_

'Copy these 3 lines of code if this is the Picedem2 proto board
'    $ifdef PICDEM2_Board    
'    Low __LCD_RWPort.__LCD_RWPin  ' Set LCD Write_Mode if this pin is set
'    $endif
'
'$ifdef PICDEM2_Board
'    Low PORTA.2
'$endif
'
           
