'****************************************************************
'*  Name    : Test2_TC74.BAS                                    *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2016 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 29/01/2016                                        *
'*  Version : 1.0                                               *
'*  Notes   :                                                   *
'*          :                                                   *
'****************************************************************

'    Include "D:/MyIncFiles/PICDEM2_18F452_4.inc"
    Include "PICDEM2_18F452_4.inc"    
    
'    Declare Create_Coff = On
'    Declare Watchdog = Off
'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = Off
'    Declare Bootloader = Off
'    Declare Icd_Req = OFF
'    Declare Show_System_Variables = On
'    Declare MemWrite_Int_Control = 1

' Addresses of diferents standard temperature sensors. 1001 101  xTC74_AddressRead
'    $define TC74A0 %01001000
'    $define TC74A1 %01001001
'    $define TC74A2 %01001010
'    $define TC74A3 %01001011
'    $define TC74A4 %01001100
'    $define TC74A5 %01001101
'    $define TC74A6 %01001110
'    $define TC74A7 %01001111

'    $define TC74A0_ADRRead %10010001
'    $define TC74A1_ADRRead %10010011
'    $define TC74A2_ADRRead %10010101    
'    $define TC74A3_ADRRead %10010111
'    $define TC74A4_ADRRead %10011001
'    $define TC74A5_ADRRead %10011011
'    $define TC74A6_ADRRead %10011101
'    $define TC74A7_ADRRead %10011111

'    $define TC74A0_ADRWrite %10010000
'    $define TC74A1_ADRWrite %10010010
'    $define TC74A2_ADRWrite %10010100    
'    $define TC74A3_ADRWrite %10010110
'    $define TC74A4_ADRWrite %10011000
'    $define TC74A5_ADRWrite %10011010
'    $define TC74A6_ADRWrite %10011100
'    $define TC74A7_ADRWrite %10011110

'    $define TC74_RTR     $00    ' Address Register: Read Temperature (TEMP REG)
'    $define TC74_RWCR    $01    ' Address Register: Read/Write Configuration (CONFIG REG)
'    $define TC74_STANDBY $80    ' Setting bit: Standby value 
'    $define TC74_NORMAL  $00    ' Setting bit: Normal value 
'===============================================================================
'    Declare Hbus_Bitrate 100
    
'    $define I2C_SDA_Pin PORTC.4
'    $define I2C_SCL_Pin PORTC.3
'    Declare Slow_Bus On    
'===============================================================================
    Dim Temp As Byte
    Dim TC74_Result As Byte
    Dim TC74_AddressWrite As Byte
    Dim TC74_AddressRead As Byte
    
	Dim THERM As Word
	Dim SIGN As Bit
 	Dim VAL_THERM As Float
     
    Dim SensorAddress As Byte
    Dim Temperature As Byte
    Dim ReturnPolarity As Byte
    Dim ReturnACK As Byte
    Dim Address As Byte
    Dim LoopCounter As Byte  
'===============================================================================
'    Include "Software_I2C.inc"

    Include "LCD_Tricks.Inc"

'    Include "D:/MyIncFiles/TC74-H.inc"
    Include "TC74-H.inc"
'=============================================================================== 
INIT_TC74:
    $ifdef _PICDEM2_
    Low PORTA.2
    $endif
    DelayMS 250
    Cls
    DelayMS 250
    Low Buzzer
    Input Buzzer
    Print "TEST TC74 Sensor"
'===============================================================================
'===============================================================================
    Symbol Addr_TC74 = %10011001
    LoopCounter = 0
    SensorAddress = TC74A4
    TC74_AddressWrite = SensorAddress << 1
    TC74_AddressRead = TC74_AddressWrite | 1
MAIN_TC74:
'-------------------------------------------------------------------------------
    Temperature = 255
    ReturnACK = 0
    HBStart
    HBusOut TC74_AddressWrite
    $ifdef _SSPCON2
    If SSPCON2.6 = 1 Then       ' (ACKSTAT) Check ACK from the sensor
        HBStop
        ReturnACK = 1          ' Set A NACK error
        GoTo OverRead
    EndIf
    $endif
    HBusOut TC74_RWCR
    HBusOut TC74_NORMAL
    HBStop

    DelayMS 255

'    HBStart
'    HBusOut TC74_AddressWrite
'    $ifdef _SSPCON2
'    If SSPCON2.6 = 1 Then       ' (ACKSTAT) Check ACK from the sensor
'        HBStop
'        ReturnACK = 1          ' Set A NACK error
'        goto OverRead  
'    EndIf
'    $endif
'    HBusOut TC74_RTR
'    HBReStart
'    HBusOut TC74_AddressRead
'    HBusIn Temperature
'    HBusNack
'    HBStop

'    If Temperature.7 = 1 Then          
'        Temperature = ~Temperature + 1    
'        ReturnPolarity = 1                ' It is a negative Result.
'    Else                                    
'        ReturnPolarity = 0                ' It is a positive result.
'    EndIf
OverRead:
'-------------------------------------------------------------------------------
    Temperature = TC74_ReadSRTemp(SensorAddress, ReturnPolarity, ReturnACK)
'    Temperature = TC74_ReadTemp(TC74A4, ReturnPolarity, ReturnACK)
'-------------------------------------------------------------------------------
    If ReturnACK.0 = 0 Then
        If ReturnPolarity = 0 Then
            HRSOut "Temperature: +", Dec Temperature, " Degrees ", IBin8 Temperature, CR
            LCD_Clear_Row(2)
            Cursor 2,1 : Print "Temp +", Dec Temperature, %11011111, "C"
            ' The value %11011111 is the special character for Degre ().
        Else
            HRSOut "Temperature: -", Dec Temperature, " Degrees ", IBin8 Temperature, CR
            LCD_Clear_Row(2)
            Cursor 2,1 : Print "Temp -", Dec Temperature, %11011111, "C"
            ' The value %11011111 is the special character for Degre ().  
        EndIf
    Else            
        HRSOut "Error NACK", CR   ' Exit and Compute the NACK error
    EndIf
'    Print At 1,1, IBin8 ReturnACK, "     "
'-------------------------------------------------------------------------------
    DelayMS 3000
    GoTo MAIN_TC74
'===============================================================================
'===============================================================================
    End    
    
    

   
